/* drzefko 0.4.1
 *  by Bartosz Taudul <wolf@pld.org.pl>
 *  
 *  this thing is under gnu gpl v2
 */

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <time.h>
#include <malloc.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL.h>
#include <SDL_video.h>
#include "drzefko.h"

int minimalna_liczba_odrostow=2;
int max_liczba_odrostow=3;
int dlugosc_drzefka=5;
int jak_dokladnie_mam_rysowac_drzefko=3;
int rob_zrzuty=0;
int rozmiar_x=500;
int rozmiar_y=700;

SDL_Surface *skrin;
struct galonzka *drzefko;
int node_count=0;
int swiatlosc=1;
int polerowanie=1;

Uint32 timer_now,timer_old;
int timer_delta;

void powiedz_mi_cos_na_temat_pamieci()
{
#ifndef WIN32
	struct mallinfo dupa=mallinfo();
	
	printf("Zearem %d KB pamici.\n",dupa.uordblks/1024);
#endif
}


void czary_mary_benc_wlacz_grafike()
{
	GLfloat tmp[4];
	char tytul_okna[255];

	SDL_Init(SDL_INIT_VIDEO);
	atexit(SDL_Quit);
	
	if((skrin=SDL_SetVideoMode(rozmiar_x,rozmiar_y,24,SDL_OPENGL))==NULL)
	{
		printf("%s\n",SDL_GetError());
		exit(1);
	}
	sprintf(tytul_okna,"drzefko %s",version);
	SDL_WM_SetCaption(tytul_okna,"drzefko");

	glViewport(0,0,rozmiar_x,rozmiar_y);
	glClearColor(0,0,0,0);
	glClearDepth(1);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glEnable(GL_NORMALIZE);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0,(GLfloat)rozmiar_x/(GLfloat)rozmiar_y,0.1,100);
	glMatrixMode(GL_MODELVIEW);

	tmp[0]=tmp[1]=tmp[2]=0.1; tmp[3]=1;
	glLightfv(GL_LIGHT0,GL_AMBIENT,tmp);
	tmp[0]=tmp[1]=tmp[2]=tmp[3]=1;
	glLightfv(GL_LIGHT0,GL_DIFFUSE,tmp);
	tmp[0]=-5; tmp[1]=1; tmp[2]=4; tmp[3]=0;
	glLightfv(GL_LIGHT0,GL_POSITION,tmp);

	tmp[0]=0; tmp[1]=0; tmp[2]=2; tmp[3]=1;
	glLightfv(GL_LIGHT1,GL_DIFFUSE,tmp);
	tmp[0]=20; tmp[1]=-4; tmp[2]=0; tmp[3]=0;
	glLightfv(GL_LIGHT1,GL_POSITION,tmp);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
}

struct galonzka *zrob_galonzke(int poziom_drzefka,int odcinek_galenzi)
{
	int i,j;
	struct galonzka *dupa;

	if(poziom_drzefka<0)
		return NULL;

	if((dupa=(struct galonzka *)malloc(sizeof(struct galonzka)))==NULL)
	{
		printf("Zapomniaem co miaem zrobi.\n");
		exit(1);
	}
	node_count++;

	i=random()%(max_liczba_odrostow-minimalna_liczba_odrostow+1) \
		+minimalna_liczba_odrostow;	/* przedzia min-max */
	
	if(poziom_drzefka==jak_dokladnie_mam_rysowac_drzefko&& \
				odcinek_galenzi==0)
		i=0;			/* przy ziemi nie ma by gazi */

	if(poziom_drzefka==0)
		dupa->jaki_kolor_ma_galonzka=kolor_lisci;
	else
		dupa->jaki_kolor_ma_galonzka=kolor_galenzi;

	for(j=0;j<i;j++)
	{
		dupa->kierunek_w_jakim_spoglonda_galonzka[j]=random()%360;
		dupa->jak_bardzo_do_sloneczka_ciongnie_galonzke[j]=random()%60+40;
		dupa->opis_galonzki[j]=zrob_galonzke(poziom_drzefka-1,0);
	}
	if(i!=max_liczba_odrostow)
		for(j=i;j<max_liczba_odrostow;j++)
			dupa->opis_galonzki[j]=NULL;
	
	if((poziom_drzefka!=0)&&(odcinek_galenzi<dlugosc_drzefka)&& \
	(random()%10>1||poziom_drzefka==jak_dokladnie_mam_rysowac_drzefko))
		dupa->nastepna_galonzka= \
			zrob_galonzke(poziom_drzefka,odcinek_galenzi+1);
	else
		dupa->nastepna_galonzka=NULL;

	return dupa;
}

void zbuduj_drzefko()
{
	char tytul_okna[255];

	printf("Budowanie drzefka...\n");
	sprintf(tytul_okna,"drzefko %s - budowanie drzefka...",version);
	SDL_WM_SetCaption(tytul_okna,"drzefko");
	srandom(time(0));
	drzefko=zrob_galonzke(jak_dokladnie_mam_rysowac_drzefko,0);
	printf("Drzefko skada si z %d elementw.\n",node_count);
	sprintf(tytul_okna,"drzefko %s (%d elementw)",version,node_count);
	SDL_WM_SetCaption(tytul_okna,"drzefko");
	
	powiedz_mi_cos_na_temat_pamieci();
}

void show_node(short int kolor,int zakonczenie)
{
	if(kolor==kolor_lisci)
	{
		glCallList(dlist_lisc);
	}else if(zakonczenie==0)
	{
		glCallList(dlist_galonz);
	}else if(zakonczenie==1)
	{
		glCallList(dlist_koniec_galonzi);
	}else
		glCallList(dlist_pieniek);
}

void zbuduj_displej_listy()
{
	GLfloat tmp[4];

	/* li */
	glNewList(dlist_lisc,GL_COMPILE);
	tmp[0]=0.08; tmp[1]=0.88; tmp[2]=0.05; tmp[3]=1;
	glColor3f(0.08,0.88,0.05);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(-0.442,-0.147,-0.885);
		glVertex3f(0,1.5,-0.25);
		glVertex3f(0,0,0);
		glVertex3f(-0.3,1.5,-0.1);
		glNormal3f(-0.442,0.147,-0.885);
		glVertex3f(0,3,0);
		glNormal3f(0.442,0.147,-0.885);
		glVertex3f(0.3,1.5,-0.1);
		glNormal3f(0.442,-0.147,-0.885);
		glVertex3f(0,0,0);
	glEnd();
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(-0.418,0.143,0.897);
		glVertex3f(0,1.5,-0.24);
		glVertex3f(0,0,0);
		glVertex3f(0.3,1.5,-0.1);
		glNormal3f(-0.418,-0.143,0.897);
		glVertex3f(0,3,0);
		glNormal3f(0.418,-0.143,0.897);
		glVertex3f(-0.3,1.5,-0.1);
		glNormal3f(0.418,0.143,0.897);
		glVertex3f(0,0,0);
	glEnd();
	glEndList();

	/* ga */
	glNewList(dlist_galonz,GL_COMPILE);
	tmp[0]=0.75; tmp[1]=0.31; tmp[2]=0.05; tmp[3]=1;
	glColor3f(0.75,0.31,0.05);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_QUAD_STRIP);
		glNormal3f(0,0.005,-0.999);
		glVertex3f(-0.15,0,-0.15);
		glVertex3f(-0.135,2.5,-0.135);
		glVertex3f(0.15,0,-0.15);
		glVertex3f(0.135,2.5,-0.135);
		glNormal3f(0.999,-0.005,0);
		glVertex3f(0.15,0,0.15);
		glVertex3f(0.135,2.5,0.135);
		glNormal3f(0,-0.005,0.999);
		glVertex3f(-0.15,0,0.15);
		glVertex3f(-0.135,2.5,0.135);
		glNormal3f(-0.999,0.005,0);
		glVertex3f(-0.15,0,-0.15);
		glVertex3f(-0.135,2.5,-0.135);
	glEnd();
	glEndList();
	
	/* koniec gazi */
	glNewList(dlist_koniec_galonzi,GL_COMPILE);
	tmp[0]=0.75; tmp[1]=0.31; tmp[2]=0.05; tmp[3]=1;
	glColor3f(0.75,0.31,0.05);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0,0.0428,-0.999);
		glVertex3f(0,3.5,0);
		glVertex3f(0.15,0,-0.15);
		glVertex3f(-0.15,0,-0.15);
		glNormal3f(-0.999,0.0428,0);
		glVertex3f(-0.15,0,0.15);
		glNormal3f(0,0.0428,0.999);
		glVertex3f(0.15,0,0.15);
		glNormal3f(0.999,0.0428,0);
		glVertex3f(0.15,0,-0.15);
	glEnd();
	glEndList();

	/* podstawa */
	glNewList(dlist_pieniek,GL_COMPILE);
	tmp[0]=0.75; tmp[1]=0.31; tmp[2]=0.05; tmp[3]=1;
	glColor3f(0.75,0.31,0.05);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_QUAD_STRIP);
		glNormal3f(0,0.339,-0.941);
		glVertex3f(-0.225,0,-0.225);
		glVertex3f(-0.135,2.5,-0.135);
		glVertex3f(0.225,0,-0.225);
		glVertex3f(0.135,2.5,-0.135);
		glNormal3f(0.941,-0.339,0);
		glVertex3f(0.225,0,0.225);
		glVertex3f(0.135,2.5,0.135);
		glNormal3f(0,-0.338,0.941);
		glVertex3f(-0.225,0,0.225);
		glVertex3f(-0.135,2.5,0.135);
		glNormal3f(-0.941,0.338,0);
		glVertex3f(-0.225,0,-0.225);
		glVertex3f(-0.135,2.5,-0.135);
	glEnd();
	/* teren na ktrym drzefko stoi */
	tmp[0]=0; tmp[1]=0.94; tmp[2]=0; tmp[3]=1;
	glColor3f(0,0.94,0);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,tmp);
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0,1,0);
		glVertex3f(0,0,0);
		glVertex3f(-4,0,-2);
		glVertex3f(-4,0,2);
		glVertex3f(-2,0,4);
		glVertex3f(2,0,4);
		glVertex3f(4,0,2);
		glVertex3f(4,0,-2);
		glVertex3f(2,0,-4);
		glVertex3f(-2,0,-4);
		glVertex3f(-4,0,-2);
	glEnd();
	glEndList();
}

void narysuj_galonzke(struct galonzka *dupa)
{
	int i;

	show_node(dupa->jaki_kolor_ma_galonzka, \
		(dupa==drzefko?2:(dupa->nastepna_galonzka==NULL?1:0)));
	
	for(i=0;i<max_liczba_odrostow;i++)
		if(dupa->opis_galonzki[i]!=NULL)
		{
			glPushMatrix();
			glTranslatef(0,2,0);
			if(dupa->opis_galonzki[i]->nastepna_galonzka!=NULL) // to nie li
				glScalef(0.7,0.7,0.7);
			else
				glScalef(0.9,0.9,0.9);
			glRotatef(dupa->kierunek_w_jakim_spoglonda_galonzka[i],0,1,0);
			glRotatef(dupa->jak_bardzo_do_sloneczka_ciongnie_galonzke[i],0,0,1);
			narysuj_galonzke(dupa->opis_galonzki[i]);
			glPopMatrix();
		}
	
	if(dupa->nastepna_galonzka!=NULL)
	{
		glPushMatrix();
		glTranslatef(0,2,0);
		glScalef(0.9,0.9,0.9);
		narysuj_galonzke(dupa->nastepna_galonzka);
		glPopMatrix();
	}
}

void narysuj_drzefko()
{
	double obrot=0;
	int i;
	SDL_Event zderzenie;
	char tytul_okna[255];
	SDL_Surface *temp;
	SDL_Surface *image;
	int idx;
	
	glNewList(dlist_full,GL_COMPILE);
	narysuj_galonzke(drzefko);
	glEndList();
	timer_now=timer_old=SDL_GetTicks();
	timer_delta=0;

	if(rob_zrzuty==0)
	{
		while(1)
		{
			SDL_PollEvent(&zderzenie);
			if(zderzenie.type==SDL_QUIT)
				exit(0);
			if(zderzenie.type==SDL_KEYDOWN)
				switch(zderzenie.key.keysym.sym)
				{
					case SDLK_ESCAPE:
						exit(0);
						break;
					case SDLK_l:
						swiatlosc=swiatlosc?0:1;
						if(!swiatlosc)
						{
							glDisable(GL_LIGHTING);
							printf("Bez owietlenia\n");
						}else{
							glEnable(GL_LIGHTING);
							printf("Z owietleniem\n");
						}
						break;
					case SDLK_s:
						polerowanie=polerowanie?0:1;
						if(!polerowanie)
						{
							glShadeModel(GL_FLAT);
							printf("Flat shading.\n");
						}else{
							glShadeModel(GL_SMOOTH);
							printf("Smooth shading.\n");
						}
						break;
					default:
						printf("I co klawisze bez sensu naciskasz?!\n");
				}
		
			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
			glLoadIdentity();
			glTranslatef(0,-5,-20);
			glRotatef(obrot+=timer_delta*0.033,0,1,0);
//			narysuj_galonzke(drzefko);
			glCallList(dlist_full);
			SDL_GL_SwapBuffers();
			timer_now=SDL_GetTicks();
			timer_delta=timer_now-timer_old;
			timer_old=timer_now;
		}
	}else if(rob_zrzuty==1){
		/* tutaj robimy 72 obrazki i zrzucamy je do plikw */
		for(i=0;i<72;i++)
		{
			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
			glLoadIdentity();
			glTranslatef(0,-5,-20);
			glRotatef(obrot+=5,0,1,0);
//			narysuj_galonzke(drzefko);
			glCallList(dlist_full);
			SDL_GL_SwapBuffers();
			
			sprintf(tytul_okna,"drzefko %s - %i%% zrobione",version,(int)(((float)i/72.0)*100.0));
			SDL_WM_SetCaption(tytul_okna,"drzefko");
			
			image=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
			temp=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
			glReadPixels(0,0,rozmiar_x,rozmiar_y,GL_RGB,GL_UNSIGNED_BYTE,image->pixels);
			for(idx=0;idx<rozmiar_y;idx++)
				memcpy(temp->pixels+3*rozmiar_x*idx,(char *)image->pixels+3*rozmiar_x*(rozmiar_y-idx),3*rozmiar_x);
			SDL_SaveBMP(temp, zrzuty[i]);
			SDL_FreeSurface(image);
			SDL_FreeSurface(temp);
		}
	}else{
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();
		glTranslatef(0,-5,-20);
//		narysuj_galonzke(drzefko);
		glCallList(dlist_full);
		SDL_GL_SwapBuffers();
		
		sprintf(tytul_okna,"drzefko %s",version);
		SDL_WM_SetCaption(tytul_okna,"drzefko");
		
		image=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
		temp=SDL_CreateRGBSurface(SDL_SWSURFACE, rozmiar_x, rozmiar_y, 24, 0x0000FF, 0x00FF00, 0xFF0000,0x000000);
		glReadPixels(0,0,rozmiar_x,rozmiar_y,GL_RGB,GL_UNSIGNED_BYTE,image->pixels);
		for(idx=0;idx<rozmiar_y;idx++)
			memcpy(temp->pixels+3*rozmiar_x*idx,(char *)image->pixels+3*rozmiar_x*(rozmiar_y-idx),3*rozmiar_x);
		SDL_SaveBMP(temp, "screenshot.bmp");
		SDL_FreeSurface(image);
		SDL_FreeSurface(temp);
	}
}

void przedstaw_siem()
{
	printf("  drzefko %s\n",version);
	printf("by Bartosz Taudul <wolf@pld.org.pl>\n\n");
	printf("Opcje konfiguracyjne: %d/%d/%d/%d\n", \
			minimalna_liczba_odrostow,max_liczba_odrostow, \
			dlugosc_drzefka, jak_dokladnie_mam_rysowac_drzefko);
}

void pomoc()
{
	printf("  drzefko %s
by Bartosz Taudul <wolf@pld.org.pl>

	-d %i	dugo gazi
	-h	ta pomoc
	-m %i	minimalna liczba gazi
	-M %i	maksymalna liczba gazi (<=10)
	-r %i	stopie rekursywnoci (wicej ni 5 nie ma sensu)
	-v	pokaz wersj i wyjd
	-x %i	szeroko okna
	-y %i	wysoko okna
	-z %i	1 -- jeden screenshot
		2 -- 72 screenshoty (peny obrt)\n",version, \
		dlugosc_drzefka, \
		minimalna_liczba_odrostow, \
		max_liczba_odrostow, \
		jak_dokladnie_mam_rysowac_drzefko, \
		rozmiar_x, \
		rozmiar_y, \
		rob_zrzuty);
}

int main(int argc,char *argv[])
{
	int c,d;

	while(1)
	{
		c=getopt(argc,argv,"d:hm:M:r:vx:y:z:");
		if(c==-1)
			break;
		
		switch(c)
		{
			case 'd':
				d=atoi(optarg);
				if(d<1)
					printf("Niepoprawna warto parametru -d\n");
				else
					dlugosc_drzefka=d;
				break;

			case 'r':
				d=atoi(optarg);
				if(d<0)
					printf("Niepoprawna warto parametru -r\n");
				else
					jak_dokladnie_mam_rysowac_drzefko=d;
				break;
			
			case 'h':
				pomoc();
				exit(0);
				break;

			case 'm':
				d=atoi(optarg);
				if(d<0)
					printf("Niepoprawna warto parametru -m\n");
				else
					minimalna_liczba_odrostow=d;
				break;

			case 'M':
				d=atoi(optarg);
				if(d<0||d>10)
					printf("Niepoprawna warto parametru -d\n");
				else
					max_liczba_odrostow=d;
				break;

			case 'v':
				przedstaw_siem();
				exit(0);
				break;

			case 'x':
				d=atoi(optarg);
				if(d<1)
					printf("Niepoprawna warto parametru -m\n");
				else
					rozmiar_x=d;
				break;

			case 'y':
				d=atoi(optarg);
				if(d<1)
					printf("Niepoprawna warto parametru -m\n");
				else
					rozmiar_y=d;
				break;

			case 'z':
				d=atoi(optarg);
				if(d<0||d>2)
					printf("Za warto opcji -z\n");
				else
					rob_zrzuty=d;
				break;

			case '?':
				pomoc();
				exit(0);
				break;

			default:
				printf("Huh?\n");
				break;
		}
	}

	przedstaw_siem();
	czary_mary_benc_wlacz_grafike();
	zbuduj_displej_listy();
	zbuduj_drzefko();
	narysuj_drzefko();

	return 0;
}
